SystemOrganization addCategory: #ControlTests!

TestCase subclass: #ControlTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ControlTests'!

!ControlTests commentStamp: 'fbs 3/31/2011 17:34' prior: 0!
This class exercises the shift/reset control operators.!

!ControlTests methodsFor: 'testing' stamp: 'fbs 4/14/2011 17:24'!
testExceptionWithinShiftEscapesContinuation
	| fun returnValue |
	fun := [ Exception signal: [ :k | k value: '2' ] shift ].
	self
		should: [ fun reset ]
		raise: Exception
		description: 'Reset ate the thrown exception'.
		
	[ fun reset ]
		on: Exception do: [ :e | returnValue := e messageText ].
	self assert: returnValue = '2' description: 'k returned wrong value'.! !

!ControlTests methodsFor: 'testing' stamp: 'fbs 3/31/2011 17:36'!
testResetDoesNothingOnItsOwn
	| fun |
	fun := [1 + 2].
	self assert: fun value = fun reset.! !

!ControlTests methodsFor: 'testing' stamp: 'fbs 4/14/2011 16:41'!
testResetDoesntEatExceptions
	self
		should: [ [ Exception signal ] reset ]
		raise: Exception
		description: 'Reset ate the thrown exception'.! !

!ControlTests methodsFor: 'testing' stamp: 'fbs 4/14/2011 17:27'!
testShiftMakesReentrantContinuation
	| cont |
	self assert: [ 2 + [ :k | cont := k. k value: 0 ] shift ] reset = 2.
	
	self assert: (cont value: 2) = 4.
	self assert: (cont value: 4) = 6.! !

!ControlTests methodsFor: 'testing' stamp: 'fbs 4/14/2011 15:20'!
testShiftReifiesStackAsFunction
	self assert: (1 + [2 + [ :k | 3 + (k value: 4) ] shift ] reset) = 10.
	self assert: (1 + [2 + [:k | 3 + (k value: 5) + (k value: 1)] shift ] reset) = 14.! !

!ControlTests methodsFor: 'testing' stamp: 'fbs 4/14/2011 15:20'!
testShiftWithNoResetRaisesException
	self
		should: [[ :k | 1 + 2] shift]
		raise: MissingResetException
		description: 'No missing reset exception for BlockClosure>>shift'.! !

!ControlTests methodsFor: 'testing' stamp: 'fbs 3/31/2011 17:54'!
testUnusedShiftThrowsAwayCallStack
	self assert: 1 + [2 + [:k | 3] shift] reset = 4.! !
